package gui;

import java.awt.EventQueue;
import java.awt.event.ActionEvent;
import java.awt.event.WindowEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowListener;
import java.io.IOException;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.net.SocketException;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.Hashtable;

import javax.swing.*;
import javax.swing.border.Border;
import javax.swing.table.DefaultTableModel;
import javax.swing.text.AbstractDocument;

import server.LoginException;
import server.UnnavailableLoginException;
import server.User;
import voip.Voice;

import net.ConnectionInfo;
import net.TimeoutLimitException;

import client.ChatThread;
import client.ClientGuiListener;
import client.FachadaClient;
import client.ServerException;
import client.UpdateListThread;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * FriendList.java
 *
 * Created on 02/06/2011, 16:41:53
 */
/**
 * 
 * @author Pedro
 */
public class FriendList extends javax.swing.JFrame implements ClientGuiListener {
	private String login;
	private String addedLogin;
	private ArrayList<Integer> aberta;
	private LoginScreen janelaLogin;
	private Hashtable<InetAddress, String> tabelaDeContatos;
	private Hashtable<InetAddress, GroupChatWindow> tabelaDeJanelas;
	private FachadaClient fachada;
	private DefaultListModel modelo;
	private boolean iniciou;
	private String senha;
	/** Creates new form FriendList */
	public FriendList(String login,String senha, FachadaClient fachada, LoginScreen janelaLogin) {
		// modificar a inicialização do ArrayList quando implementar servidor
		this.tabelaDeJanelas = new Hashtable<InetAddress, GroupChatWindow>();
		this.janelaLogin = janelaLogin;
		this.fachada = fachada;
		this.iniciou = false;
		this.senha = senha;
		fachada.addListener(this);
		aberta = new ArrayList<Integer>();
		/*
		 * tem que pegar a lista de contatos do servidor e jogar aqui e
		 * inicializar tudo como false a cada contato novo que adicionar,
		 * também inicializa como false
		 */
		this.login = login;
		modelo = new DefaultListModel();
		tabelaDeContatos = new Hashtable<InetAddress, String>();
		initComponents();
		this.addWindowListener(new WindowAdapterLogin(this.fachada) {
			public void windowClosing(WindowEvent ev) {
				try {
					this.getFachada().logout();
				} catch (TimeoutLimitException e) {

				}
			}
		});
		iniciou = true;
	}

	public void setFachada(FachadaClient fachada) {
		this.fachada = fachada;
	}

	public void mostrarMensagem(String error) {
		JOptionPane.showMessageDialog(null, error);
	}
	public boolean reconnectMessage(){
		int coisa = JOptionPane.showConfirmDialog(null,
				"Deseja reconectar?", "No foi possivel se conectar com o servidor", JOptionPane.WARNING_MESSAGE);
		if(coisa == 0){
			return true;
		}else{
			return false;
		}
	}
	/**
	 * This method is called from within the constructor to initialize the form.
	 * WARNING: Do NOT modify this code. The content of this method is always
	 * regenerated by the Form Editor.
	 */
	@SuppressWarnings("unchecked")
	// <editor-fold defaultstate="collapsed"
	// desc="Generated Code">//GEN-BEGIN:initComponents
	private void initComponents() {
//		Object[] amigos = fachada.getFriends();
//		for(int i = 0; i < amigos.length; i++){
//			modelo.addElement(amigos[i]);
//			aberta.add(1);
//		}
		addDialog = new javax.swing.JDialog();
		loginChildField = new javax.swing.JTextField();
		loginChildLabel = new javax.swing.JLabel();
		addChildButton = new javax.swing.JButton();
		cancelChildButton = new javax.swing.JButton();
		editDialog = new javax.swing.JDialog();
		headerLabel = new javax.swing.JLabel();
		enviarButton = new javax.swing.JButton();
		cancelarButton = new javax.swing.JButton();
		nomeLabel = new javax.swing.JLabel();
		novaSenhaLabel = new javax.swing.JLabel();
		confirmLabel = new javax.swing.JLabel();
		twitterLabel = new javax.swing.JLabel();
		emailLabel = new javax.swing.JLabel();
		senhaAtualLabel = new javax.swing.JLabel();
		senhaAtualField = new javax.swing.JPasswordField();
		confirmField = new javax.swing.JPasswordField();
		novaSenhaField = new javax.swing.JPasswordField();
		nomeField = new javax.swing.JTextField();
		twitterField = new javax.swing.JTextField();
		loginLabel = new javax.swing.JLabel();
		ImageIcon pic = new ImageIcon("addbutton.jpg");
		addButton = new javax.swing.JButton(pic);
		scrollPane = new javax.swing.JScrollPane();
		contactsTable = new javax.swing.JList(modelo);
		menuBar = new javax.swing.JMenuBar();
		jMenu1 = new javax.swing.JMenu();
		adicionarContatoMenu = new javax.swing.JMenuItem();
		editMenu = new javax.swing.JMenuItem();
		sairMenu = new javax.swing.JMenuItem();

		addDialog.setTitle("Adicionar Amigo");
		addDialog.setAlwaysOnTop(true);
		addDialog.setMinimumSize(new java.awt.Dimension(280, 95));
		addDialog.setUndecorated(true);
		this.contactsTable.addMouseListener(new MyMouseAdapter(aberta,this.login,
				contactsTable.getSelectedIndex(), this.tabelaDeJanelas) {
			public void mouseClicked(java.awt.event.MouseEvent e) {
				Object temp = contactsTable.getSelectedValue();
				if ((contactsTable.getSelectedValue() != null)
						&& (aberta.get(contactsTable.getSelectedIndex()) == 1)) {
					String name = ((User)contactsTable.getSelectedValue()).getLogin();

					//contactsTable.getSelectedValue().conneciotaneoigna
					
					//
					
					//
					if(temp instanceof User){
						ConnectionInfo ciTemp = ((User)temp).getConnectionInfo();
						if (ciTemp != null) {
							if (!tabelaDeJanelas.containsKey(ciTemp.getIp())) {
								System.out.println("janela NOVA");
								Hashtable<ConnectionInfo, String> tabela = new Hashtable<ConnectionInfo, String>();
								tabela.put(ciTemp, name);
								GroupChatWindow test = new GroupChatWindow(login, fachada, tabela, modelo);
								
								tabelaDeJanelas.put(ciTemp.getIp(), test);
								
								test.setVisible(true);
								aberta.set(contactsTable.getSelectedIndex(), 0);

								test.addWindowListener(new MyWindowAdapter(
										aberta, contactsTable
												.getSelectedIndex()) {
									public void windowClosing(WindowEvent ev) {
										aberta.set(position, 1);
									}
								});
							}else{
								System.out.println("JANELA ANTIGA");
								tabelaDeJanelas.get(ciTemp.getIp()).setVisible(true);
							}
						}
					}
				}
			}
		});

		// Action contactsTableButton = new AbstractAction()
		// {
		// public void actionPerformed(ActionEvent e)
		// {
		// JTable table = (JTable)e.getSource();
		// int modelRow = Integer.valueOf( e.getActionCommand() );
		// if(aberta.get(modelRow)==1){
		// String name =
		// ((DefaultTableModel)table.getModel()).getValueAt(modelRow,
		// 0).toString();
		// ChatWindow test = new ChatWindow(name);
		// test.setVisible(true);
		// aberta.set(modelRow, 0);
		// test.addWindowListener(new MyWindowAdapter(aberta, modelRow) {
		// public void windowClosing(WindowEvent ev) {
		// aberta.set(position, 1);
		// }
		// });
		// }
		// }
		// };
		//	        
		loginChildField.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				loginChildFieldActionPerformed(evt);
			}
		});
		AbstractDocument doc = (AbstractDocument) loginChildField.getDocument();
		doc.setDocumentFilter(new DocumentSizeFilter(10));

		loginChildLabel.setText("Login:");

		addChildButton.setText("Adicionar");
		addChildButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				addChildButtonActionPerformed(evt);
			}
		});

		cancelChildButton.setText("Cancelar");
		cancelChildButton
				.addActionListener(new java.awt.event.ActionListener() {
					public void actionPerformed(java.awt.event.ActionEvent evt) {
						cancelChildButtonActionPerformed(evt);
					}
				});

		javax.swing.GroupLayout addDialogLayout = new javax.swing.GroupLayout(
				addDialog.getContentPane());
		addDialog.getContentPane().setLayout(addDialogLayout);
		addDialogLayout
				.setHorizontalGroup(addDialogLayout
						.createParallelGroup(
								javax.swing.GroupLayout.Alignment.LEADING)
						.addGroup(
								addDialogLayout
										.createSequentialGroup()
										.addGap(25, 25, 25)
										.addGroup(
												addDialogLayout
														.createParallelGroup(
																javax.swing.GroupLayout.Alignment.LEADING)
														.addGroup(
																addDialogLayout
																		.createSequentialGroup()
																		.addGap(
																				4,
																				4,
																				4)
																		.addComponent(
																				addChildButton)
																		.addPreferredGap(
																				javax.swing.LayoutStyle.ComponentPlacement.RELATED)
																		.addComponent(
																				cancelChildButton))
														.addGroup(
																addDialogLayout
																		.createSequentialGroup()
																		.addComponent(
																				loginChildLabel)
																		.addPreferredGap(
																				javax.swing.LayoutStyle.ComponentPlacement.RELATED)
																		.addComponent(
																				loginChildField,
																				javax.swing.GroupLayout.DEFAULT_SIZE,
																				137,
																				Short.MAX_VALUE)))
										.addContainerGap(21, Short.MAX_VALUE)));
		addDialogLayout
				.setVerticalGroup(addDialogLayout
						.createParallelGroup(
								javax.swing.GroupLayout.Alignment.LEADING)
						.addGroup(
								addDialogLayout
										.createSequentialGroup()
										.addGap(19, 19, 19)
										.addGroup(
												addDialogLayout
														.createParallelGroup(
																javax.swing.GroupLayout.Alignment.BASELINE)
														.addComponent(
																loginChildLabel)
														.addComponent(
																loginChildField,
																javax.swing.GroupLayout.PREFERRED_SIZE,
																javax.swing.GroupLayout.DEFAULT_SIZE,
																javax.swing.GroupLayout.PREFERRED_SIZE))
										.addGap(18, 18, 18)
										.addGroup(
												addDialogLayout
														.createParallelGroup(
																javax.swing.GroupLayout.Alignment.BASELINE)
														.addComponent(
																cancelChildButton)
														.addComponent(
																addChildButton))
										.addContainerGap(
												javax.swing.GroupLayout.DEFAULT_SIZE,
												Short.MAX_VALUE)));

		editDialog.setTitle("Modificação de Informações");
		editDialog.setMinimumSize(new java.awt.Dimension(400, 340));
		editDialog.setResizable(false);

		headerLabel
				.setText("Digite abaixo as informações que deseja modificar:");

		enviarButton.setText("Enviar");
		enviarButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				enviarButtonActionPerformed(evt);
			}
		});

		cancelarButton.setText("Cancelar");
		cancelarButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				cancelarButtonActionPerformed(evt);
			}
		});

		nomeLabel.setText("Nome:");

		novaSenhaLabel.setText("Nova senha:");

		confirmLabel.setText("Confirme senha:");

		twitterLabel.setText("Twitter:");

		emailLabel.setText("Email:");

		senhaAtualLabel.setFont(new java.awt.Font("Tahoma", 3, 11));
		senhaAtualLabel.setText("Senha atual:");

		AbstractDocument senhaAtualFielddoc = (AbstractDocument) senhaAtualField
				.getDocument();
		senhaAtualFielddoc.setDocumentFilter(new DocumentSizeFilter(10));
		senhaAtualField.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				senhaAtualFieldActionPerformed(evt);
			}
		});

		AbstractDocument confirmFielddoc = (AbstractDocument) confirmField
				.getDocument();
		confirmFielddoc.setDocumentFilter(new DocumentSizeFilter(10));

		AbstractDocument novaSenhaFielddoc = (AbstractDocument) novaSenhaField
				.getDocument();
		novaSenhaFielddoc.setDocumentFilter(new DocumentSizeFilter(10));

		AbstractDocument nomeFielddoc = (AbstractDocument) nomeField
				.getDocument();
		nomeFielddoc.setDocumentFilter(new DocumentSizeFilter(40));

		AbstractDocument twitterFielddoc = (AbstractDocument) twitterField
				.getDocument();
		twitterFielddoc.setDocumentFilter(new DocumentSizeFilter(40));

		javax.swing.GroupLayout editDialogLayout = new javax.swing.GroupLayout(
				editDialog.getContentPane());
		editDialog.getContentPane().setLayout(editDialogLayout);
		editDialogLayout
				.setHorizontalGroup(editDialogLayout
						.createParallelGroup(
								javax.swing.GroupLayout.Alignment.LEADING)
						.addGroup(
								editDialogLayout
										.createSequentialGroup()
										.addContainerGap()
										.addGroup(
												editDialogLayout
														.createParallelGroup(
																javax.swing.GroupLayout.Alignment.LEADING)
														.addComponent(
																headerLabel)
														.addGroup(
																javax.swing.GroupLayout.Alignment.TRAILING,
																editDialogLayout
																		.createSequentialGroup()
																		.addComponent(
																				enviarButton,
																				javax.swing.GroupLayout.DEFAULT_SIZE,
																				210,
																				Short.MAX_VALUE)
																		.addPreferredGap(
																				javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
																		.addComponent(
																				cancelarButton,
																				javax.swing.GroupLayout.PREFERRED_SIZE,
																				114,
																				javax.swing.GroupLayout.PREFERRED_SIZE)
																		.addGap(
																				42,
																				42,
																				42))
														.addGroup(
																editDialogLayout
																		.createSequentialGroup()
																		.addGroup(
																				editDialogLayout
																						.createParallelGroup(
																								javax.swing.GroupLayout.Alignment.TRAILING)
																						.addGroup(
																								javax.swing.GroupLayout.Alignment.LEADING,
																								editDialogLayout
																										.createSequentialGroup()
																										.addGap(
																												97,
																												97,
																												97)
																										.addComponent(
																												senhaAtualLabel)
																										.addGap(
																												18,
																												18,
																												18)
																										.addComponent(
																												senhaAtualField,
																												javax.swing.GroupLayout.PREFERRED_SIZE,
																												121,
																												javax.swing.GroupLayout.PREFERRED_SIZE))
																						.addGroup(
																								javax.swing.GroupLayout.Alignment.LEADING,
																								editDialogLayout
																										.createSequentialGroup()
																										.addGroup(
																												editDialogLayout
																														.createParallelGroup(
																																javax.swing.GroupLayout.Alignment.TRAILING)
																														.addComponent(
																																novaSenhaLabel)
																														.addComponent(
																																nomeLabel)
																														.addComponent(
																																confirmLabel)
																														.addComponent(
																																twitterLabel)
																														.addComponent(
																																emailLabel))
																										.addPreferredGap(
																												javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
																										.addGroup(
																												editDialogLayout
																														.createParallelGroup(
																																javax.swing.GroupLayout.Alignment.LEADING)
																														.addComponent(
																																confirmField,
																																javax.swing.GroupLayout.DEFAULT_SIZE,
																																227,
																																Short.MAX_VALUE)
																														.addComponent(
																																novaSenhaField,
																																javax.swing.GroupLayout.DEFAULT_SIZE,
																																227,
																																Short.MAX_VALUE)
																														.addComponent(
																																nomeField,
																																javax.swing.GroupLayout.DEFAULT_SIZE,
																																227,
																																Short.MAX_VALUE)
																														.addComponent(
																																twitterField,
																																javax.swing.GroupLayout.DEFAULT_SIZE,
																																227,
																																Short.MAX_VALUE))))
																		.addGap(
																				60,
																				60,
																				60)))
										.addContainerGap()));
		editDialogLayout
				.setVerticalGroup(editDialogLayout
						.createParallelGroup(
								javax.swing.GroupLayout.Alignment.LEADING)
						.addGroup(
								editDialogLayout
										.createSequentialGroup()
										.addContainerGap()
										.addComponent(headerLabel)
										.addGap(36, 36, 36)
										.addGroup(
												editDialogLayout
														.createParallelGroup(
																javax.swing.GroupLayout.Alignment.BASELINE)
														.addComponent(nomeLabel)
														.addComponent(
																nomeField,
																javax.swing.GroupLayout.PREFERRED_SIZE,
																javax.swing.GroupLayout.DEFAULT_SIZE,
																javax.swing.GroupLayout.PREFERRED_SIZE))
										.addGap(18, 18, 18)
										.addGroup(
												editDialogLayout
														.createParallelGroup(
																javax.swing.GroupLayout.Alignment.BASELINE)
														.addComponent(
																novaSenhaLabel)
														.addComponent(
																novaSenhaField,
																javax.swing.GroupLayout.PREFERRED_SIZE,
																javax.swing.GroupLayout.DEFAULT_SIZE,
																javax.swing.GroupLayout.PREFERRED_SIZE))
										.addGap(18, 18, 18)
										.addGroup(
												editDialogLayout
														.createParallelGroup(
																javax.swing.GroupLayout.Alignment.BASELINE)
														.addComponent(
																confirmLabel)
														.addComponent(
																confirmField,
																javax.swing.GroupLayout.PREFERRED_SIZE,
																javax.swing.GroupLayout.DEFAULT_SIZE,
																javax.swing.GroupLayout.PREFERRED_SIZE))
										.addGap(18, 18, 18)
										.addGroup(
												editDialogLayout
														.createParallelGroup(
																javax.swing.GroupLayout.Alignment.BASELINE)
														.addComponent(
																twitterLabel)
														.addComponent(
																twitterField,
																javax.swing.GroupLayout.PREFERRED_SIZE,
																javax.swing.GroupLayout.DEFAULT_SIZE,
																javax.swing.GroupLayout.PREFERRED_SIZE))
										.addGap(18, 18, 18)
										.addComponent(emailLabel)
										.addPreferredGap(
												javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
										.addGroup(
												editDialogLayout
														.createParallelGroup(
																javax.swing.GroupLayout.Alignment.BASELINE)
														.addComponent(
																senhaAtualLabel)
														.addComponent(
																senhaAtualField,
																javax.swing.GroupLayout.PREFERRED_SIZE,
																javax.swing.GroupLayout.DEFAULT_SIZE,
																javax.swing.GroupLayout.PREFERRED_SIZE))
										.addPreferredGap(
												javax.swing.LayoutStyle.ComponentPlacement.RELATED,
												17, Short.MAX_VALUE)
										.addGroup(
												editDialogLayout
														.createParallelGroup(
																javax.swing.GroupLayout.Alignment.BASELINE)
														.addComponent(
																enviarButton)
														.addComponent(
																cancelarButton))
										.addContainerGap()));

		setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
		setTitle("Bear Talk");

		loginLabel.setFont(new java.awt.Font("Tahoma", 0, 24));
		loginLabel.setText(login);

		addButton.setText(null);
		addButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				addButtonActionPerformed(evt);
			}
		});

		contactsTable.setBackground(new java.awt.Color(243, 245, 244));
		contactsTable.setFont(new java.awt.Font("Tahoma", 0, 14)); // NOI18N

		contactsTable.setAutoscrolls(false);
		contactsTable.setSelectionBackground(new java.awt.Color(228, 255, 254));
		scrollPane.setViewportView(contactsTable);

		jMenu1.setText("Arquivo");

		adicionarContatoMenu.setText("Adicionar Contato...");
		adicionarContatoMenu
				.addActionListener(new java.awt.event.ActionListener() {
					public void actionPerformed(java.awt.event.ActionEvent evt) {
						adicionarContatoMenuActionPerformed(evt);
					}
				});
		jMenu1.add(adicionarContatoMenu);

		editMenu.setText("Editar Informações");
		editMenu.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				editMenuActionPerformed(evt);
			}
		});
		jMenu1.add(editMenu);

		sairMenu.setText("Sair");
		sairMenu.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				sairMenuActionPerformed(evt);
			}
		});
		jMenu1.add(sairMenu);

		menuBar.add(jMenu1);

		setJMenuBar(menuBar);

		javax.swing.GroupLayout layout = new javax.swing.GroupLayout(
				getContentPane());
		getContentPane().setLayout(layout);
		layout
				.setHorizontalGroup(layout
						.createParallelGroup(
								javax.swing.GroupLayout.Alignment.LEADING)
						.addGroup(
								layout
										.createSequentialGroup()
										.addContainerGap()
										.addGroup(
												layout
														.createParallelGroup(
																javax.swing.GroupLayout.Alignment.LEADING)
														.addComponent(
																scrollPane,
																javax.swing.GroupLayout.DEFAULT_SIZE,
																363,
																Short.MAX_VALUE)
														.addGroup(
																javax.swing.GroupLayout.Alignment.TRAILING,
																layout
																		.createSequentialGroup()
																		.addComponent(
																				loginLabel,
																				javax.swing.GroupLayout.PREFERRED_SIZE,
																				223,
																				Short.MAX_VALUE)
																		.addGap(
																				18,
																				18,
																				18)
																		.addComponent(
																				addButton,
																				javax.swing.GroupLayout.PREFERRED_SIZE,
																				122,
																				javax.swing.GroupLayout.PREFERRED_SIZE)))
										.addContainerGap()));
		layout
				.setVerticalGroup(layout
						.createParallelGroup(
								javax.swing.GroupLayout.Alignment.LEADING)
						.addGroup(
								layout
										.createSequentialGroup()
										.addGroup(
												layout
														.createParallelGroup(
																javax.swing.GroupLayout.Alignment.LEADING)
														.addGroup(
																layout
																		.createSequentialGroup()
																		.addContainerGap()
																		.addComponent(
																				addButton,
																				javax.swing.GroupLayout.PREFERRED_SIZE,
																				41,
																				javax.swing.GroupLayout.PREFERRED_SIZE))
														.addGroup(
																layout
																		.createSequentialGroup()
																		.addGap(
																				18,
																				18,
																				18)
																		.addComponent(
																				loginLabel)))
										.addPreferredGap(
												javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
										.addComponent(
												scrollPane,
												javax.swing.GroupLayout.DEFAULT_SIZE,
												402, Short.MAX_VALUE)
										.addContainerGap()));

		pack();
	}// </editor-fold>//GEN-END:initComponents

	private void addButtonActionPerformed(java.awt.event.ActionEvent evt) {// GEN-FIRST:event_addButtonActionPerformed
		addDialog.setVisible(true);
	}// GEN-LAST:event_addButtonActionPerformed

	private void loginChildFieldActionPerformed(java.awt.event.ActionEvent evt) {// GEN-FIRST:event_loginChildFieldActionPerformed
		addedLogin = loginChildField.getText();
		loginChildField.setText("");
		if (addedLogin == "" || addedLogin == null) {
			this.mostrarMensagem("Favor preencher o campo");
		} else {
			try {
				this.fachada.addFriend(addedLogin);
				modelo.addElement(new User(addedLogin));
				aberta.add(1);
				addDialog.setVisible(false);
			} catch (LoginException e) {
				this.mostrarMensagem(e.getMessage());
			} catch (ServerException e) {
				this.mostrarMensagem(e.getMessage());
			} catch (TimeoutLimitException e) {
				this.mostrarMensagem(e.getMessage());
			} catch (IOException e) {
				this.mostrarMensagem(e.getMessage());
			} catch (UnnavailableLoginException e) {
				this.mostrarMensagem(e.getMessage());
			}

		}
	}// GEN-LAST:event_loginChildFieldActionPerformed

	private void addChildButtonActionPerformed(java.awt.event.ActionEvent evt) {// GEN-FIRST:event_addChildButtonActionPerformed

		addedLogin = loginChildField.getText();
		loginChildField.setText("");
		if (addedLogin == "" || addedLogin == null) {
			this.mostrarMensagem("Favor preencher o campo");
		} else {
			try {
				this.fachada.addFriend(addedLogin);
				modelo.addElement(new User(addedLogin));
				aberta.add(1);
				addDialog.setVisible(false);
			} catch (LoginException e) {
				this.mostrarMensagem(e.getMessage());
			} catch (ServerException e) {
				this.mostrarMensagem(e.getMessage());
			} catch (TimeoutLimitException e) {
				this.mostrarMensagem(e.getMessage());
			} catch (IOException e) {
				this.mostrarMensagem(e.getMessage());
			} catch (UnnavailableLoginException e) {
				this.mostrarMensagem(e.getMessage());
			}

		}
	}// GEN-LAST:event_addChildButtonActionPerformed

	private void cancelChildButtonActionPerformed(java.awt.event.ActionEvent evt) {// GEN-FIRST:event_cancelChildButtonActionPerformed
		addDialog.setVisible(false);
		loginChildField.setText("");
	}// GEN-LAST:event_cancelChildButtonActionPerformed

	private void sairMenuActionPerformed(java.awt.event.ActionEvent evt) {// GEN-FIRST:event_sairMenuActionPerformed
		try {
			fachada.logout();
		} catch (TimeoutLimitException e) {
		
		}
		Enumeration<GroupChatWindow> janelas = tabelaDeJanelas.elements();
		while(janelas.hasMoreElements()){
			janelas.nextElement().dispose();
		}
		tabelaDeJanelas.clear();
		this.dispose();
		this.janelaLogin.setVisible(true);
	}// GEN-LAST:event_sairMenuActionPerformed

	private void adicionarContatoMenuActionPerformed(
			java.awt.event.ActionEvent evt) {// GEN-FIRST:event_adicionarContatoMenuActionPerformed
		addDialog.setVisible(true);
	}// GEN-LAST:event_adicionarContatoMenuActionPerformed

	private void editMenuActionPerformed(java.awt.event.ActionEvent evt) {// GEN-FIRST:event_editMenuActionPerformed
		editDialog.setVisible(true);
	}// GEN-LAST:event_editMenuActionPerformed

	private void enviarButtonActionPerformed(java.awt.event.ActionEvent evt) {// GEN-FIRST:event_enviarButtonActionPerformed
		// TODO add your handling code here:
	}// GEN-LAST:event_enviarButtonActionPerformed

	private void cancelarButtonActionPerformed(java.awt.event.ActionEvent evt) {// GEN-FIRST:event_cancelarButtonActionPerformed
		editDialog.setVisible(false);
	}// GEN-LAST:event_cancelarButtonActionPerformed

	private void senhaAtualFieldActionPerformed(java.awt.event.ActionEvent evt) {// GEN-FIRST:event_senhaAtualFieldActionPerformed
		// TODO add your handling code here:
	}// GEN-LAST:event_senhaAtualFieldActionPerformed

	/**
	 * @param args
	 *            the command line arguments
	 */
	public static void main(String args[]) {
		java.awt.EventQueue.invokeLater(new Runnable() {
			public void run() {

			}
		});
	}

	// Variables declaration - do not modify//GEN-BEGIN:variables
	private javax.swing.JButton addButton;
	private javax.swing.JButton addChildButton;
	private javax.swing.JDialog addDialog;
	private javax.swing.JMenuItem adicionarContatoMenu;
	private javax.swing.JButton cancelChildButton;
	private javax.swing.JButton cancelarButton;
	private javax.swing.JPasswordField confirmField;
	private javax.swing.JLabel confirmLabel;
	private javax.swing.JList contactsTable;
	private javax.swing.JDialog editDialog;
	private javax.swing.JMenuItem editMenu;
	private javax.swing.JLabel emailLabel;
	private javax.swing.JButton enviarButton;
	private javax.swing.JLabel headerLabel;
	private javax.swing.JMenu jMenu1;
	private javax.swing.JTextField loginChildField;
	private javax.swing.JLabel loginChildLabel;
	private javax.swing.JLabel loginLabel;
	private javax.swing.JMenuBar menuBar;
	private javax.swing.JTextField nomeField;
	private javax.swing.JLabel nomeLabel;
	private javax.swing.JPasswordField novaSenhaField;
	private javax.swing.JLabel novaSenhaLabel;
	private javax.swing.JMenuItem sairMenu;
	private javax.swing.JScrollPane scrollPane;
	private javax.swing.JPasswordField senhaAtualField;
	private javax.swing.JLabel senhaAtualLabel;
	private javax.swing.JTextField twitterField;
	private javax.swing.JLabel twitterLabel;

	// End of variables declaration//GEN-END:variables
	@Override
	public void error(Exception e) {
		this.mostrarMensagem(e.getMessage());

	}

	@Override
	public void lostConnectionToServer() {
		System.out.println("PERDEU A CONEXO COM O SERVIDOR");
		if(this.reconnectMessage()){
			try {
				fachada.logar(this.login,this.senha);
			} catch (TimeoutLimitException e) {
				this.lostConnectionToServer();
			} catch (LoginException e) {
				
			}
		}else{
			this.dispose();
			try {
				fachada.logout();
			} catch (TimeoutLimitException e) {
			
			}
			this.janelaLogin.setVisible(true);
		}
	}

	@Override
	public void refreshFriendsList(Hashtable<String, ConnectionInfo> tabela) {

		Enumeration<?> lista = modelo.elements();
		
		while(lista.hasMoreElements()){
			Object temp = lista.nextElement();
			if(temp instanceof User){
				String login = ((User)temp).getLogin();
				if(tabela.containsKey(login)){
					((User)temp).setStatus("online");
					((User)temp).setConnectionInfo(tabela.get(login));
					tabelaDeContatos.put(tabela.get(login).getIp(), login);
					
				}else{
					((User)temp).setStatus("offline");
				}
		
				contactsTable.repaint();
			
			}
		}
	}

	@Override
	public void callRecieved(ConnectionInfo ci) {
		System.out.println("RECEBEU CHAMADA DE VOZ DE "+ci.getIp());	
		try {
			new Voice(ci, new DatagramSocket(3000)).comeco();
		} catch (SocketException e) {
			this.mostrarMensagem(e.getMessage());
		}
	}

	@Override
	public void msgRecieved(String msg, ConnectionInfo ci, ChatThread ct) {
		String login = tabelaDeContatos.get(ci.getIp());
		
		if(!tabelaDeJanelas.containsKey(ci.getIp())){
			System.out.println("JANELA no tinha sido aberta");
			Hashtable<ConnectionInfo, String> tabelaDeParticipantes = new Hashtable<ConnectionInfo, String>();
			tabelaDeParticipantes.put(ci, login);
//			ChatWindow temp = new ChatWindow(login,this.login,fachada, ci, modelo);
			GroupChatWindow  temp = new GroupChatWindow(this.login, this.fachada, tabelaDeParticipantes, modelo);
			temp.msgRecieved(msg, ci, ct);
			temp.setVisible(true);
			ct.addListener(temp);
			ct.removeListener(this);
			tabelaDeJanelas.put(ci.getIp(), temp);
		}else{
			ct.addListener(tabelaDeJanelas.get(ci.getIp()));
			ct.removeListener(this);
			System.out.println("Janela j tinha sido aberta");
		}
		
	}

	@Override
	public void transferRecieved() {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void connectionReceived(ChatThread chat, ConnectionInfo ci) {
		
	}

	@Override
	public void initFriendsList(ArrayList<String> logins) {
		while(!iniciou){
			try {
				Thread.sleep(200);
			} catch (InterruptedException e) {
				
			}
		}
		System.out.println("recebeu lista inicial "+logins);
		EventQueue.invokeLater(new UpdateListThread(this.modelo, logins));
		for(@SuppressWarnings("unused") String login : logins){
			this.aberta.add(1);
		}
	}

	@Override
	public void conviteDeConversaRecebido(ConnectionInfo ci, Hashtable<ConnectionInfo, String> tabelaDeParticipantes, ChatThread chat) {
		System.out.println("RECEBEU CONVITE DE "+ci.getIp().getHostAddress());
		System.out.println(tabelaDeParticipantes);
		String login = tabelaDeContatos.get(ci.getIp());
		tabelaDeParticipantes.put(ci, login);
		GroupChatWindow janelaGrupo = new GroupChatWindow(this.login, this.fachada,tabelaDeParticipantes , modelo);
//		fachada.connectToGroup(tabelaDeParticipantes.keys(), this, janelaGrupo);
		janelaGrupo.setVisible(true);
		//chat.addGroupListener(janelaGrupo);
	}

	@Override
	public void confirmouConvite(ConnectionInfo ci, ChatThread chat) {
		// TODO Auto-generated method stub
		
	}
}
