package voip;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.util.concurrent.ArrayBlockingQueue;


public class Receive extends Thread{
	protected DatagramSocket conexao;
	protected DatagramPacket pacote;
	protected String IP;
	protected int port;
	protected long expectedTime;
	protected ArrayBlockingQueue<byte[]> buffer;
	private int bufferSize;
	
	protected boolean vive;
	
	public Receive(ArrayBlockingQueue<byte[]> buffer, DatagramSocket conexao, String IP, int port, int bufferSize){
		this.buffer = buffer;
        this.conexao = conexao;
        this.IP = IP;
        this.port = port;
        this.bufferSize = bufferSize;

	}
	
	@Override
	public void run() {

            try{
                byte[] data = new byte[bufferSize + 12];

                long timestamp;

                expectedTime = 0;
                vive = true;
        		while(vive){
        			pacote = new DatagramPacket(data, data.length);
        			
                    conexao.receive(pacote);                       
                    data = pacote.getData();

                    timestamp = ByteOp.getLong(data, 4, 8);
                    System.out.println(timestamp);
                    
                    if (timestamp >= expectedTime) {
                    	buffer.add(data);
                        expectedTime = timestamp;
                        
                    }

        		}
            }catch(Exception e){
            	e.printStackTrace();
            }
		
		
	}
	
	public void kill(){
		vive = false;
	}

}
