package voip;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.net.SocketException;
import java.util.concurrent.ArrayBlockingQueue;

import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.DataLine;
import javax.sound.sampled.SourceDataLine;
import javax.sound.sampled.TargetDataLine;

import net.ConnectionInfo;

public class Voice {

	private InetAddress IP;
	private DatagramSocket conexao;
	private ArrayBlockingQueue<byte[]> buffer;

	private int bufferSize;
	Receive receptor;
	Capture capturador;
	Play tocador;


	public Voice(ConnectionInfo conn, DatagramSocket conexao) throws SocketException {
		this.IP = conn.getIp();
		this.conexao = conexao;
		buffer = new ArrayBlockingQueue<byte[]>(100);
		bufferSize = 320;
		// receptor = new Receive(buffer, conexao, IP, porta,
		// bufferSize);
		capturador = new Capture(conexao, IP, bufferSize);
		tocador = new Play(buffer, conexao, bufferSize);

	}

	public void comeco() {

		// receptor.start();

		capturador.start();

		tocador.start();

	}

	public void termino() throws InterruptedException {
		// receptor.kill();
		capturador.kill();
		tocador.kill();
		Thread.sleep(1000);
	}
}